package trip.model;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

public class JavaClass extends JavaType {

	private Set<JavaInterface> implementedInterfaces;
	private JavaClass superclass;	
	
	public JavaClass(String name) {
		super(name);
	}
	public JavaClass(String name, JavaPackage parent) {
		super(name);
		setParent(parent);
	}
	
	/**
	 * Sets the superclass of this class. Using a null superclass
	 * will cause this class to be superclassed by java.lang.Object.
	 * 
	 * @throws IllegalArgumentException If the given superclass is this class.
	 * @param superclass The JavaClass to use as this class's superclass.
	 */
	public void setSuperclass(JavaClass superclass) {
		if (superclass == this) throw new IllegalArgumentException
			("A class cannot be its own superclass.");
		
		this.superclass = superclass;
	}
	
	public JavaClass getSuperclass() {
		return superclass;
	}
}
