package trip.model;

/**
 * A Java method parameter.
 *
 */
public class JavaParameter extends JavaLeafComponent {

	private String name;
	private JavaType type;
	private boolean isFinal = false;
	
	/**
	 * Constructor for a new JavaParameter.
	 * @param name The name of the parameter.
	 * @param type The return type of the parameter.
	 */
	public JavaParameter(String name, JavaType type) {
		this.name = name;
		this.type = type;
	}
	
	/**
	 * Constructor for a new JavaParameter.
	 * @param name The name of the parameter.
	 * @param type The return type of the parameter.
	 * @param isFinal Whether the parameter is a <code>final</code> parameter.
	 */
	public JavaParameter(String name, JavaType type, boolean isFinal) {
		this.name = name;
		this.type = type;
		this.isFinal = isFinal;
	}
	
	public String getName() { return name; }
	public JavaType getType() { return type; }
	
	public boolean isFinal() {
		return isFinal;
	}
	public void setIsFinal(boolean isFinal) {
		this.isFinal = isFinal;
	}
}
