package trip.model.commands;

import java.util.ArrayList;
import java.util.List;

/**
 * This file was automatically generated from the trip diagram at: 
 * Wed Sep 29 11:53:55 NZDT 2010
 */


public class CompoundCommand extends Command {

	private List<Command> commands;
	
    public void addCommand(Command cmmd) {
    	if (commands == null) commands = new ArrayList<Command>();
	}

	public void removeCommand(Command cmmd) {
		if (commands == null) return;
		commands.remove(cmmd);
	}

	public void execute() {
		for (Command cmmd : commands) cmmd.execute();
	}

	public boolean canUndo() {
		for (Command cmmd : commands) 
			if (!cmmd.canUndo()) return false;
		return true;
	}
	
	public void undo() {
		for (Command cmmd : commands) cmmd.undo();
	}

	public boolean canRedo() {
		for (Command cmmd : commands)
			if (!cmmd.canRedo()) return false;
		return true;
	}
	
	public void redo() {
		for (Command cmmd : commands) cmmd.redo();
	}
}