package trip.model.commands;

import trip.model.JavaType;


public class RenameTypeCommand extends Command {

	private String oldName;
	private String newName;
	private JavaType type;
	
    public RenameTypeCommand(JavaType type, String name) {
    	this.type = type;
    	this.newName = name;
    }

	
	public void execute() {
		oldName = type.getName();
		redo();
	}
	
	public boolean canUndo() {
		return oldName != null;
	}
	
	public void undo() {
		type.setName(oldName);
	}
	
	public boolean canRedo() {
		return oldName != null;
	}
	
	public void redo() {
		type.setName(newName);
	}
}