package trip.model.commands;

import trip.data.IModelProvider;
import trip.model.JavaType;

public class RenameTypeInCodeCommand extends Command {

	private String oldName;
	private String newName;
	private JavaType type;
	private IModelProvider provider;
	
    public RenameTypeInCodeCommand(IModelProvider provider, JavaType type, String newName) {
    	this.provider = provider;
    	this.type = type;
    	this.newName = newName;
    }

	public void execute() {
		oldName = type.getName();
		redo();
	}
	public void undo() {
		provider.renameType(type, oldName);
	}
	public void redo() {
		provider.renameType(type, newName);
	}
}