package trip.model.commands;

import trip.transaction.Transaction;


public class TransactionalCommand extends Command {


	private Command immediateCommand;
	public Command queuedCommand;
	private Transaction transaction;
	
    public TransactionalCommand(Transaction transaction, Command immediateCommand, Command queuedCommand) {
    	this.transaction = transaction;
    	this.immediateCommand = immediateCommand;
    	this.queuedCommand = queuedCommand;
    }


	public void execute() {
		transaction.addCommand(queuedCommand);
		immediateCommand.execute();
	}

	public boolean canUndo() {
		return immediateCommand.canUndo();
	}
	
	public void undo() {
		transaction.removeCommand(queuedCommand);
		immediateCommand.undo();
	}

	public boolean canRedo() {
		return immediateCommand.canRedo();
	}
	
	public void redo() {
		transaction.addCommand(queuedCommand);
		immediateCommand.redo();
	}

}